.\" Automatically generated from an mdoc input file.  Do not edit.
.\"
.\" SPDX-License-Identifier: ISC
.\"
.\" Copyright (c) 1994-1996, 1998-2005, 2007-2019
.\"	Todd C. Miller <Todd.Miller@sudo.ws>
.\"
.\" Permission to use, copy, modify, and distribute this software for any
.\" purpose with or without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\" WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\" ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\" ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\" OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.\" Sponsored in part by the Defense Advanced Research Projects
.\" Agency (DARPA) and Air Force Research Laboratory, Air Force
.\" Materiel Command, USAF, under agreement number F39502-99-1-0512.
.\"
.nr SL 0
.nr BA 0
.nr LC 0
.nr PS 0
.TH "SUDO" "8" "October 20, 2019" "Sudo 1.8.29" "System Manager's Manual"
.nh
.if n .ad l
.SH "NAME"
\fBsudo\fR,
\fBsudoedit\fR
\- execute a command as another user
.SH "SYNOPSIS"
.HP 5n
\fBsudo\fR
\fB\-h\fR\ |\ \fB\-K\fR\ |\ \fB\-k\fR\ |\ \fB\-V\fR
.br
.PD 0
.HP 5n
\fBsudo\fR
\fB\-v\fR
[\fB\-ABknS\fR]
.if \n(BA [\fB\-a\fR\ \fItype\fR]
[\fB\-g\fR\ \fIgroup\fR]
[\fB\-h\fR\ \fIhost\fR]
[\fB\-p\fR\ \fIprompt\fR]
[\fB\-u\fR\ \fIuser\fR]
.br
.HP 5n
\fBsudo\fR
\fB\-l\fR
[\fB\-ABknS\fR]
.if \n(BA [\fB\-a\fR\ \fItype\fR]
[\fB\-g\fR\ \fIgroup\fR]
[\fB\-h\fR\ \fIhost\fR]
[\fB\-p\fR\ \fIprompt\fR]
[\fB\-U\fR\ \fIuser\fR]
[\fB\-u\fR\ \fIuser\fR]
[\fIcommand\fR]
.br
.HP 5n
\fBsudo\fR
[\fB\-ABbEHnPS\fR]
.if \n(BA [\fB\-a\fR\ \fItype\fR]
[\fB\-C\fR\ \fInum\fR]
.if \n(LC [\fB\-c\fR\ \fIclass\fR]
[\fB\-g\fR\ \fIgroup\fR]
[\fB\-h\fR\ \fIhost\fR]
[\fB\-p\fR\ \fIprompt\fR]
.if \n(SL [\fB\-r\fR\ \fIrole\fR]
.if \n(SL [\fB\-t\fR\ \fItype\fR]
[\fB\-T\fR\ \fItimeout\fR]
[\fB\-u\fR\ \fIuser\fR]
[\fIVAR\fR=\fIvalue\fR]
[\fB\-i\fR\ |\ \fB\-s\fR]
[\fIcommand\fR]
.br
.HP 9n
\fBsudoedit\fR
[\fB\-ABknS\fR]
.if \n(BA [\fB\-a\fR\ \fItype\fR]
[\fB\-C\fR\ \fInum\fR]
.if \n(LC [\fB\-c\fR\ \fIclass\fR]
[\fB\-g\fR\ \fIgroup\fR]
[\fB\-h\fR\ \fIhost\fR]
[\fB\-p\fR\ \fIprompt\fR]
[\fB\-T\fR\ \fItimeout\fR]
[\fB\-u\fR\ \fIuser\fR]
\fIfile\ ...\fR
.PD
.SH "DESCRIPTION"
\fBsudo\fR
allows a permitted user to execute a
\fIcommand\fR
as the superuser or another user, as specified by the security
policy.
The invoking user's real
(\fInot\fR effective)
user-ID is used to determine the user name with which
to query the security policy.
.PP
\fBsudo\fR
supports a plugin architecture for security policies and input/output
logging.
Third parties can develop and distribute their own policy and I/O
logging plugins to work seamlessly with the
\fBsudo\fR
front end.
The default security policy is
\fIsudoers\fR,
which is configured via the file
\fI/private/etc/sudoers\fR,
or via LDAP.
See the
\fIPlugins\fR
section for more information.
.PP
The security policy determines what privileges, if any, a user has
to run
\fBsudo\fR.
The policy may require that users authenticate themselves with a
password or another authentication mechanism.
If authentication is required,
\fBsudo\fR
will exit if the user's password is not entered within a configurable
time limit.
This limit is policy-specific; the default password prompt timeout
for the
\fIsudoers\fR
security policy is
unlimited.
.PP
Security policies may support credential caching to allow the user
to run
\fBsudo\fR
again for a period of time without requiring authentication.
The
\fIsudoers\fR
policy caches credentials for
\fR5\fR
minutes, unless overridden in
sudoers(5).
By running
\fBsudo\fR
with the
\fB\-v\fR
option, a user can update the cached credentials without running a
\fIcommand\fR.
.PP
When invoked as
\fBsudoedit\fR,
the
\fB\-e\fR
option (described below), is implied.
.PP
Security policies may log successful and failed attempts to use
\fBsudo\fR.
If an I/O plugin is configured, the running command's input and
output may be logged as well.
.PP
The options are as follows:
.TP 12n
\fB\-A\fR, \fB\--askpass\fR
Normally, if
\fBsudo\fR
requires a password, it will read it from the user's terminal.
If the
\fB\-A\fR (\fIaskpass\fR)
option is specified, a (possibly graphical) helper program is
executed to read the user's password and output the password to the
standard output.
If the
\fRSUDO_ASKPASS\fR
environment variable is set, it specifies the path to the helper
program.
Otherwise, if
sudo.conf(5)
contains a line specifying the askpass program, that value will be
used.
For example:
.nf
.sp
.RS 16n
# Path to askpass helper program
Path askpass /usr/X11R6/bin/ssh-askpass
.RE
.fi
.RS 12n
.sp
If no askpass program is available,
\fBsudo\fR
will exit with an error.
.RE
.if \n(BA \{\
.TP 12n
\fB\-a\fR \fItype\fR, \fB\--auth-type\fR=\fItype\fR
Use the specified
BSD
authentication
\fItype\fR
when validating the user, if allowed by
\fI/etc/login.conf\fR.
The system administrator may specify a list of sudo-specific
authentication methods by adding an
\(lqauth-sudo\(rq
entry in
\fI/etc/login.conf\fR.
This option is only available on systems that support
BSD
authentication.
.\}
.TP 12n
\fB\-B\fR, \fB\--bell\fR
Ring the bell as part of the password promp when a terminal is present.
This option has no effect if an askpass program is used.
.TP 12n
\fB\-b\fR, \fB\--background\fR
Run the given command in the background.
Note that it is not possible to use shell job control to manipulate
background processes started by
\fBsudo\fR.
Most interactive commands will fail to work properly in background
mode.
.TP 12n
\fB\-C\fR \fInum\fR, \fB\--close-from\fR=\fInum\fR
Close all file descriptors greater than or equal to
\fInum\fR
before executing a command.
Values less than three are not permitted.
By default,
\fBsudo\fR
will close all open file descriptors other than standard input,
standard output and standard error when executing a command.
The security policy may restrict the user's ability to use this option.
The
\fIsudoers\fR
policy only permits use of the
\fB\-C\fR
option when the administrator has enabled the
\fIclosefrom_override\fR
option.
.if \n(LC \{\
.TP 12n
\fB\-c\fR \fIclass\fR, \fB\--login-class\fR=\fIclass\fR
Run the command with resource limits and scheduling priority of
the specified login
\fIclass\fR.
The
\fIclass\fR
argument can be either a class name as defined in
\fI/etc/login.conf\fR,
or a single
\(oq\-\(cq
character.
If
\fIclass\fR
is
\fB-\fR,
the default login class of the target user will be used.
Otherwise, the command must be run as the superuser (user-ID 0), or
\fBsudo\fR
must be run from a shell that is already running as the superuser.
If the command is being run as a login shell, additional
\fI/etc/login.conf\fR
settings, such as the umask and environment variables, will
be applied, if present.
This option is only available on systems with
BSD
login classes.
.\}
.TP 12n
\fB\-E\fR, \fB\--preserve-env\fR
Indicates to the security policy that the user wishes to
preserve their existing environment variables.
The security policy may return an error if the user does not have
permission to preserve the environment.
.TP 12n
\fB\--preserve-env=list\fR
Indicates to the security policy that the user wishes to add the
comma-separated list of environment variables to those preserved
from the user's environment.
The security policy may return an error if the user does not have
permission to preserve the environment.
.TP 12n
\fB\-e\fR, \fB\--edit\fR
Edit one or more files instead of running a command.
In lieu of a path name, the string "sudoedit" is used when consulting
the security policy.
If the user is authorized by the policy, the following steps are
taken:
.RS 16n
.TP 5n
1.\&
Temporary copies are made of the files to be edited with the owner
set to the invoking user.
.TP 5n
2.\&
The editor specified by the policy is run to edit the temporary
files.
The
\fIsudoers\fR
policy uses the
\fRSUDO_EDITOR\fR,
\fRVISUAL\fR
and
\fREDITOR\fR
environment variables (in that order).
If none of
\fRSUDO_EDITOR\fR,
\fRVISUAL\fR
or
\fREDITOR\fR
are set, the first program listed in the
\fIeditor\fR
sudoers(5)
option is used.
.TP 5n
3.\&
If they have been modified, the temporary files are copied back to
their original location and the temporary versions are removed.
.RE
.RS 12n
.sp
To help prevent the editing of unauthorized files, the following
restrictions are enforced unless explicitly allowed by the security policy:
.RS 16n
.TP 3n
\fB\(bu\fR
Symbolic links may not be edited (version 1.8.15 and higher).
.TP 3n
\fB\(bu\fR
Symbolic links along the path to be edited are not followed when the
parent directory is writable by the invoking user unless that user
is root (version 1.8.16 and higher).
.TP 3n
\fB\(bu\fR
Files located in a directory that is writable by the invoking user may
not be edited unless that user is root (version 1.8.16 and higher).
.RE
.sp
Users are never allowed to edit device special files.
.sp
If the specified file does not exist, it will be created.
Note that unlike most commands run by
\fIsudo\fR,
the editor is run with the invoking user's environment unmodified.
If, for some reason,
\fBsudo\fR
is unable to update a file with its edited version, the user will
receive a warning and the edited copy will remain in a temporary
file.
.RE
.TP 12n
\fB\-g\fR \fIgroup\fR, \fB\--group\fR=\fIgroup\fR
Run the command with the primary group set to
\fIgroup\fR
instead of the primary group specified by the target
user's password database entry.
The
\fIgroup\fR
may be either a group name or a numeric group-ID
(GID)
prefixed with the
\(oq#\(cq
character (e.g.,
\fR#0\fR
for GID 0).
When running a command as a GID, many shells require that the
\(oq#\(cq
be escaped with a backslash
(\(oq\e\(cq).
If no
\fB\-u\fR
option is specified, the command will be run as the invoking user.
In either case, the primary group will be set to
\fIgroup\fR.
The
\fIsudoers\fR
policy permits any of the target user's groups to be specified via
the
\fB\-g\fR
option as long as the
\fB\-P\fR
option is not in use.
.TP 12n
\fB\-H\fR, \fB\--set-home\fR
Request that the security policy set the
\fRHOME\fR
environment variable to the home directory specified by the target
user's password database entry.
Depending on the policy, this may be the default behavior.
.TP 12n
\fB\-h\fR, \fB\--help\fR
Display a short help message to the standard output and exit.
.TP 12n
\fB\-h\fR \fIhost\fR, \fB\--host\fR=\fIhost\fR
Run the command on the specified
\fIhost\fR
if the security policy plugin supports remote commands.
Note that the
\fIsudoers\fR
plugin does not currently support running remote commands.
This may also be used in conjunction with the
\fB\-l\fR
option to list a user's privileges for the remote host.
.TP 12n
\fB\-i\fR, \fB\--login\fR
Run the shell specified by the target user's password database entry
as a login shell.
This means that login-specific resource files such as
\fI.profile\fR,
\fI.bash_profile\fR
or
\fI.login\fR
will be read by the shell.
If a command is specified, it is passed to the shell for execution
via the shell's
\fB\-c\fR
option.
If no command is specified, an interactive shell is executed.
\fBsudo\fR
attempts to change to that user's home directory before running the
shell.
The command is run with an environment similar to the one
a user would receive at log in.
Note that most shells behave differently when a command is specified
as compared to an interactive session; consult the shell's manual
for details.
The
\fICommand environment\fR
section in the
sudoers(5)
manual documents how the
\fB\-i\fR
option affects the environment in which a command is run when the
\fIsudoers\fR
policy is in use.
.TP 12n
\fB\-K\fR, \fB\--remove-timestamp\fR
Similar to the
\fB\-k\fR
option, except that it removes the user's cached credentials entirely
and may not be used in conjunction with a command or other option.
This option does not require a password.
Not all security policies support credential caching.
.TP 12n
\fB\-k\fR, \fB\--reset-timestamp\fR
When used without a command, invalidates the user's cached credentials.
In other words, the next time
\fBsudo\fR
is run a password will be required.
This option does not require a password and was added to allow a
user to revoke
\fBsudo\fR
permissions from a
\fI.logout\fR
file.
.sp
When used in conjunction with a command or an option that may require
a password, this option will cause
\fBsudo\fR
to ignore the user's cached credentials.
As a result,
\fBsudo\fR
will prompt for a password (if one is required by the security
policy) and will not update the user's cached credentials.
.sp
Not all security policies support credential caching.
.TP 12n
\fB\-l\fR, \fB\--list\fR
If no
\fIcommand\fR
is specified,
list the allowed (and forbidden) commands for the
invoking user (or the user specified by the
\fB\-U\fR
option) on the current host.
A longer list format is used if this option is specified multiple times
and the security policy supports a verbose output format.
.sp
If a
\fIcommand\fR
is specified and is permitted by the security policy, the fully-qualified
path to the command is displayed along with any command line
arguments.
If a
\fIcommand\fR
is specified but not allowed by the policy,
\fBsudo\fR
will exit with a status value of 1.
.TP 12n
\fB\-n\fR, \fB\--non-interactive\fR
Avoid prompting the user for input of any kind.
If a password is required for the command to run,
\fBsudo\fR
will display an error message and exit.
.TP 12n
\fB\-P\fR, \fB\--preserve-groups\fR
Preserve the invoking user's group vector unaltered.
By default, the
\fIsudoers\fR
policy will initialize the group vector to the list of groups the
target user is a member of.
The real and effective group-IDs, however, are still set to match
the target user.
.TP 12n
\fB\-p\fR \fIprompt\fR, \fB\--prompt\fR=\fIprompt\fR
Use a custom password prompt with optional escape sequences.
The following percent
(\(oq%\(cq)
escape sequences are supported by the
\fIsudoers\fR
policy:
.PP
.RS 12n
.PD 0
.TP 4n
\fR%H\fR
expanded to the host name including the domain name (on if the
machine's host name is fully qualified or the
\fIfqdn\fR
option is set in
sudoers(5))
.PD
.TP 4n
\fR%h\fR
expanded to the local host name without the domain name
.TP 4n
\fR%p\fR
expanded to the name of the user whose password is being requested
(respects the
\fIrootpw\fR,
\fItargetpw\fR,
and
\fIrunaspw\fR
flags in
sudoers(5))
.TP 4n
\fR\&%U\fR
expanded to the login name of the user the command will be run as
(defaults to root unless the
\fB\-u\fR
option is also specified)
.TP 4n
\fR%u\fR
expanded to the invoking user's login name
.TP 4n
\fR%%\fR
two consecutive
\(oq%\(cq
characters are collapsed into a single
\(oq%\(cq
character
.PP
The custom prompt will override the default prompt specified by either
the security policy or the
\fRSUDO_PROMPT\fR
environment variable.
On systems that use PAM, the custom prompt will also override the prompt
specified by a PAM module unless the
\fIpassprompt_override\fR
flag is disabled in
\fIsudoers\fR.
.RE
.if \n(SL \{\
.TP 12n
\fB\-r\fR \fIrole\fR, \fB\--role\fR=\fIrole\fR
Run the command with an SELinux security context that includes
the specified
\fIrole\fR.
.\}
.TP 12n
\fB\-S\fR, \fB\--stdin\fR
Write the prompt to the standard error and read the password from the
standard input instead of using the terminal device.
.TP 12n
\fB\-s\fR, \fB\--shell\fR
Run the shell specified by the
\fRSHELL\fR
environment variable if it is set or the shell specified by the
invoking user's password database entry.
If a command is specified, it is passed to the shell for execution
via the shell's
\fB\-c\fR
option.
If no command is specified, an interactive shell is executed.
Note that most shells behave differently when a command is specified
as compared to an interactive session; consult the shell's manual
for details.
.if \n(SL \{\
.TP 12n
\fB\-t\fR \fItype\fR, \fB\--type\fR=\fItype\fR
Run the command with an SELinux security context that includes
the specified
\fItype\fR.
If no
\fItype\fR
is specified, the default type is derived from the role.
.\}
.TP 12n
\fB\-U\fR \fIuser\fR, \fB\--other-user\fR=\fIuser\fR
Used in conjunction with the
\fB\-l\fR
option to list the privileges for
\fIuser\fR
instead of for the invoking user.
The security policy may restrict listing other users' privileges.
The
\fIsudoers\fR
policy only allows root or a user with the
\fRALL\fR
privilege on the current host to use this option.
.TP 12n
\fB\-T\fR \fItimeout\fR, \fB\--command-timeout\fR=\fItimeout\fR
Used to set a timeout for the command.
If the timeout expires before the command has exited, the
command will be terminated.
The security policy may restrict the ability to set command timeouts.
The
\fIsudoers\fR
policy requires that user-specified timeouts be explicitly enabled.
.TP 12n
\fB\-u\fR \fIuser\fR, \fB\--user\fR=\fIuser\fR
Run the command as a user other than the default target user
(usually
\fIroot\fR).
The
\fIuser\fR
may be either a user name or a numeric user-ID
(UID)
prefixed with the
\(oq#\(cq
character (e.g.,
\fR#0\fR
for UID 0).
When running commands as a UID, many shells require that the
\(oq#\(cq
be escaped with a backslash
(\(oq\e\(cq).
Some security policies may restrict UIDs
to those listed in the password database.
The
\fIsudoers\fR
policy allows UIDs that are not in the password database as long as the
\fItargetpw\fR
option is not set.
Other security policies may not support this.
.TP 12n
\fB\-V\fR, \fB\--version\fR
Print the
\fBsudo\fR
version string as well as the version string of the security
policy plugin and any I/O plugins.
If the invoking user is already root the
\fB\-V\fR
option will display the arguments passed to configure when
\fBsudo\fR
was built and plugins may display more verbose information such as
default options.
.TP 12n
\fB\-v\fR, \fB\--validate\fR
Update the user's cached credentials, authenticating the user
if necessary.
For the
\fIsudoers\fR
plugin, this extends the
\fBsudo\fR
timeout for another
\fR5\fR
minutes by default, but does not run a command.
Not all security policies support cached credentials.
.TP 12n
\fB\--\fR
The
\fB\--\fR
option indicates that
\fBsudo\fR
should stop processing command line arguments.
.PP
Environment variables to be set for the command may also be passed
on the command line in the form of
\fIVAR\fR=\fIvalue\fR,
e.g.,
\fRLD_LIBRARY_PATH\fR=\fI/usr/local/pkg/lib\fR.
Variables passed on the command line are subject to restrictions
imposed by the security policy plugin.
The
\fIsudoers\fR
policy subjects variables passed on the command line to the same
restrictions as normal environment variables with one important
exception.
If the
\fIsetenv\fR
option is set in
\fIsudoers\fR,
the command to be run has the
\fRSETENV\fR
tag set or the command matched is
\fRALL\fR,
the user may set variables that would otherwise be forbidden.
See
sudoers(5)
for more information.
.SH "COMMAND EXECUTION"
When
\fBsudo\fR
executes a command, the security policy specifies the execution
environment for the command.
Typically, the real and effective user and group and IDs are set to
match those of the target user, as specified in the password database,
and the group vector is initialized based on the group database
(unless the
\fB\-P\fR
option was specified).
.PP
The following parameters may be specified by security policy:
.TP 3n
\fB\(bu\fR
real and effective user-ID
.TP 3n
\fB\(bu\fR
real and effective group-ID
.TP 3n
\fB\(bu\fR
supplementary group-IDs
.TP 3n
\fB\(bu\fR
the environment list
.TP 3n
\fB\(bu\fR
current working directory
.TP 3n
\fB\(bu\fR
file creation mode mask (umask)
.if \n(SL \{\
.TP 3n
\fB\(bu\fR
SELinux role and type
.\}
.if \n(PS \{\
.TP 3n
\fB\(bu\fR
Solaris project
.\}
.if \n(PS \{\
.TP 3n
\fB\(bu\fR
Solaris privileges
.\}
.if \n(LC \{\
.TP 3n
\fB\(bu\fR
BSD
login class
.\}
.TP 3n
\fB\(bu\fR
scheduling priority (aka nice value)
.SS "Process model"
There are two distinct ways
\fBsudo\fR
can run a command.
.PP
If an I/O logging plugin is configured or if the security policy
explicitly requests it, a new pseudo-terminal
(\(lqpty\(rq)
is allocated and
fork(2)
is used to create a second
\fBsudo\fR
process, referred to as the
\fImonitor\fR.
The
\fImonitor\fR
creates a new terminal session with itself as the leader and the pty as its
controlling terminal, calls
fork(2),
sets up the execution environment as described above, and then uses the
execve(2)
system call to run the command in the child process.
The
\fImonitor\fR
exists to relay job control signals between the user's
existing terminal and the pty the command is being run in.
This makes it possible to suspend and resume the command.
Without the monitor, the command would be in what POSIX terms an
\(lqorphaned process group\(rq
and it would not receive any job control signals from the kernel.
When the command exits or is terminated by a signal, the
\fImonitor\fR
passes the command's exit status to the main
\fBsudo\fR
process and exits.
After receiving the command's exit status, the main
\fBsudo\fR
passes the command's exit status to the security policy's close function
and exits.
.PP
If no pty is used,
\fBsudo\fR
calls
fork(2),
sets up the execution environment as described above, and uses the
execve(2)
system call to run the command in the child process.
The main
\fBsudo\fR
process waits until the command has completed, then passes the
command's exit status to the security policy's close function and exits.
As a special case, if the policy plugin does not define a close
function,
\fBsudo\fR
will execute the command directly instead of calling
fork(2)
first.
The
\fIsudoers\fR
policy plugin will only define a close function when I/O logging
is enabled, a pty is required, or the
\fIpam_session\fR
or
\fIpam_setcred\fR
options are enabled.
Note that
\fIpam_session\fR
and
\fIpam_setcred\fR
are enabled by default on systems using PAM.
.SS "Signal handling"
When the command is run as a child of the
\fBsudo\fR
process,
\fBsudo\fR
will relay signals it receives to the command.
The
\fRSIGINT\fR
and
\fRSIGQUIT\fR
signals are only relayed when the command is being run in a new pty
or when the signal was sent by a user process, not the kernel.
This prevents the command from receiving
\fRSIGINT\fR
twice each time the user enters control-C.
Some signals, such as
\fRSIGSTOP\fR
and
\fRSIGKILL\fR,
cannot be caught and thus will not be relayed to the command.
As a general rule,
\fRSIGTSTP\fR
should be used instead of
\fRSIGSTOP\fR
when you wish to suspend a command being run by
\fBsudo\fR.
.PP
As a special case,
\fBsudo\fR
will not relay signals that were sent by the command it is running.
This prevents the command from accidentally killing itself.
On some systems, the
reboot(8)
command sends
\fRSIGTERM\fR
to all non-system processes other than itself before rebooting
the system.
This prevents
\fBsudo\fR
from relaying the
\fRSIGTERM\fR
signal it received back to
reboot(8),
which might then exit before the system was actually rebooted,
leaving it in a half-dead state similar to single user mode.
Note, however, that this check only applies to the command run by
\fBsudo\fR
and not any other processes that the command may create.
As a result, running a script that calls
reboot(8)
or
shutdown(8)
via
\fBsudo\fR
may cause the system to end up in this undefined state unless the
reboot(8)
or
shutdown(8)
are run using the
\fBexec\fR()
family of functions instead of
\fBsystem\fR()
(which interposes a shell between the command and the calling process).
.PP
If no I/O logging plugins are loaded and the policy plugin has not
defined a
\fBclose\fR()
function, set a command timeout or required that the command be
run in a new pty,
\fBsudo\fR
may execute the command directly instead of running it as a child process.
.SS "Plugins"
Plugins may be specified via
\fRPlugin\fR
directives in the
sudo.conf(5)
file.
They may be loaded as dynamic shared objects (on systems that support them),
or compiled directly into the
\fBsudo\fR
binary.
If no
sudo.conf(5)
file is present, or it contains no
\fRPlugin\fR
lines,
\fBsudo\fR
will use the traditional
\fIsudoers\fR
security policy and I/O logging.
See the
sudo.conf(5)
manual for details of the
\fI/private/etc/sudo.conf\fR
file and the
sudo_plugin(5)
manual for more information about the
\fBsudo\fR
plugin architecture.
.SH "EXIT VALUE"
Upon successful execution of a command, the exit status from
\fBsudo\fR
will be the exit status of the program that was executed.
If the command terminated due to receipt of a signal,
\fBsudo\fR
will send itself the same signal that terminated the command.
.PP
If the
\fB\-l\fR
option was specified without a command,
\fBsudo\fR
will exit with a value of 0 if the user is allowed to run
\fBsudo\fR
and they authenticated successfully (as required by the security policy).
If a command is specified with the
\fB\-l\fR
option, the exit value will only be 0 if the command is permitted by the
security policy, otherwise it will be 1.
.PP
If there is an authentication failure, a configuration/permission
problem or if the given command cannot be executed,
\fBsudo\fR
exits with a value of 1.
In the latter case, the error string is printed to the standard error.
If
\fBsudo\fR
cannot
stat(2)
one or more entries in the user's
\fRPATH\fR,
an error is printed to the standard error.
(If the directory does not exist or if it is not really a directory,
the entry is ignored and no error is printed.)
This should not happen under normal circumstances.
The most common reason for
stat(2)
to return
\(lqpermission denied\(rq
is if you are running an automounter and one of the directories in
your
\fRPATH\fR
is on a machine that is currently unreachable.
.SH "SECURITY NOTES"
\fBsudo\fR
tries to be safe when executing external commands.
.PP
To prevent command spoofing,
\fBsudo\fR
checks "." and "" (both denoting current directory) last when
searching for a command in the user's
\fRPATH\fR
(if one or both are in the
\fRPATH\fR).
Note, however, that the actual
\fRPATH\fR
environment variable is
\fInot\fR
modified and is passed unchanged to the program that
\fBsudo\fR
executes.
.PP
Users should
\fInever\fR
be granted
\fBsudo\fR
privileges to execute files that are writable by the user or
that reside in a directory that is writable by the user.
If the user can modify or replace the command there is no way
to limit what additional commands they can run.
.PP
Please note that
\fBsudo\fR
will normally only log the command it explicitly runs.
If a user runs a command such as
\fRsudo su\fR
or
\fRsudo sh\fR,
subsequent commands run from that shell are not subject to
\fBsudo\fR's
security policy.
The same is true for commands that offer shell escapes (including
most editors).
If I/O logging is enabled, subsequent commands will have their input and/or
output logged, but there will not be traditional logs for those commands.
Because of this, care must be taken when giving users access to commands via
\fBsudo\fR
to verify that the command does not inadvertently give the user an
effective root shell.
For more information, please see the
\fIPreventing shell escapes\fR
section in
sudoers(5).
.PP
To prevent the disclosure of potentially sensitive information,
\fBsudo\fR
disables core dumps by default while it is executing (they are
re-enabled for the command that is run).
This historical practice dates from a time when most operating
systems allowed set-user-ID processes to dump core by default.
To aid in debugging
\fBsudo\fR
crashes, you may wish to re-enable core dumps by setting
\(lqdisable_coredump\(rq
to false in the
sudo.conf(5)
file as follows:
.nf
.sp
.RS 6n
Set disable_coredump false
.RE
.fi
.PP
See the
sudo.conf(5)
manual for more information.
.SH "ENVIRONMENT"
\fBsudo\fR
utilizes the following environment variables.
The security policy has control over the actual content of the command's
environment.
.TP 17n
\fREDITOR\fR
Default editor to use in
\fB\-e\fR
(sudoedit) mode if neither
\fRSUDO_EDITOR\fR
nor
\fRVISUAL\fR
is set.
.TP 17n
\fRMAIL\fR
Set to the mail spool of the target user when the
\fB\-i\fR
option is specified or when
\fIenv_reset\fR
is enabled in
\fIsudoers\fR
(unless
\fRMAIL\fR
is present in the
\fIenv_keep\fR
list).
.TP 17n
\fRHOME\fR
Set to the home directory of the target user when the
\fB\-i\fR
or
\fB\-H\fR
options are specified, when the
\fB\-s\fR
option is specified and
\fIset_home\fR
is set in
\fIsudoers\fR,
when
\fIalways_set_home\fR
is enabled in
\fIsudoers\fR,
or when
\fIenv_reset\fR
is enabled in
\fIsudoers\fR
and
\fIHOME\fR
is not present in the
\fIenv_keep\fR
list.
.TP 17n
\fRLOGNAME\fR
Set to the login name of the target user when the
\fB\-i\fR
option is specified, when the
\fIset_logname\fR
option is enabled in
\fIsudoers\fR
or when the
\fIenv_reset\fR
option is enabled in
\fIsudoers\fR
(unless
\fRLOGNAME\fR
is present in the
\fIenv_keep\fR
list).
.TP 17n
\fRPATH\fR
May be overridden by the security policy.
.TP 17n
\fRSHELL\fR
Used to determine shell to run with
\fB\-s\fR
option.
.TP 17n
\fRSUDO_ASKPASS\fR
Specifies the path to a helper program used to read the password
if no terminal is available or if the
\fB\-A\fR
option is specified.
.TP 17n
\fRSUDO_COMMAND\fR
Set to the command run by sudo.
.TP 17n
\fRSUDO_EDITOR\fR
Default editor to use in
\fB\-e\fR
(sudoedit) mode.
.TP 17n
\fRSUDO_GID\fR
Set to the group-ID of the user who invoked sudo.
.TP 17n
\fRSUDO_PROMPT\fR
Used as the default password prompt unless
the
\fB\-p\fR
option was specified.
.TP 17n
\fRSUDO_PS1\fR
If set,
\fRPS1\fR
will be set to its value for the program being run.
.TP 17n
\fRSUDO_UID\fR
Set to the user-ID of the user who invoked sudo.
.TP 17n
\fRSUDO_USER\fR
Set to the login name of the user who invoked sudo.
.TP 17n
\fRUSER\fR
Set to the same value as
\fRLOGNAME\fR,
described above.
.TP 17n
\fRVISUAL\fR
Default editor to use in
\fB\-e\fR
(sudoedit) mode if
\fRSUDO_EDITOR\fR
is not set.
.SH "FILES"
.TP 26n
\fI/private/etc/sudo.conf\fR
\fBsudo\fR
front end configuration
.SH "EXAMPLES"
Note: the following examples assume a properly configured security
policy.
.PP
To get a file listing of an unreadable directory:
.nf
.sp
.RS 6n
$ sudo ls /usr/local/protected
.RE
.fi
.PP
To list the home directory of user yaz on a machine where the file
system holding ~yaz is not exported as root:
.nf
.sp
.RS 6n
$ sudo -u yaz ls ~yaz
.RE
.fi
.PP
To edit the
\fIindex.html\fR
file as user www:
.nf
.sp
.RS 6n
$ sudoedit -u www ~www/htdocs/index.html
.RE
.fi
.PP
To view system logs only accessible to root and users in the adm
group:
.nf
.sp
.RS 6n
$ sudo -g adm more /var/log/syslog
.RE
.fi
.PP
To run an editor as jim with a different primary group:
.nf
.sp
.RS 6n
$ sudoedit -u jim -g audio ~jim/sound.txt
.RE
.fi
.PP
To shut down a machine:
.nf
.sp
.RS 6n
$ sudo shutdown -r +15 "quick reboot"
.RE
.fi
.PP
To make a usage listing of the directories in the /home partition.
Note that this runs the commands in a sub-shell to make the
\fRcd\fR
and file redirection work.
.nf
.sp
.RS 6n
$ sudo sh -c "cd /home ; du -s * | sort -rn > USAGE"
.RE
.fi
.SH "DIAGNOSTICS"
Error messages produced by
\fBsudo\fR
include:
.TP 6n
\fRediting files in a writable directory is not permitted\fR
By default,
\fBsudoedit\fR
does not permit editing a file when any of the parent directories are writable
by the invoking user.
This avoids a race condition that could allow the user to overwrite
an arbitrary file.
See the
\fIsudoedit_checkdir\fR
option in
sudoers(5)
for more information.
.TP 6n
\fRediting symbolic links is not permitted\fR
By default,
\fBsudoedit\fR
does not follow symbolic links when opening files.
See the
\fIsudoedit_follow\fR
option in
sudoers(5)
for more information.
.TP 6n
\fReffective uid is not 0, is sudo installed setuid root?\fR
\fBsudo\fR
was not run with root privileges.
The
\fBsudo\fR
binary must be owned by the root user and have the set-user-ID bit set.
Also, it must not be located on a file system mounted with the
\(oqnosuid\(cq
option or on an NFS file system that maps uid 0 to an unprivileged uid.
.TP 6n
\fReffective uid is not 0, is sudo on a file system with the 'nosuid' option set or an NFS file system without root privileges?\fR
\fBsudo\fR
was not run with root privileges.
The
\fBsudo\fR
binary has the proper owner and permissions but it still did not run
with root privileges.
The most common reason for this is that the file system the
\fBsudo\fR
binary is located on is mounted with the
\(oqnosuid\(cq
option or it is an NFS file system that maps uid 0 to an unprivileged uid.
.TP 6n
\fRfatal error, unable to load plugins\fR
An error occurred while loading or initializing the plugins specified in
sudo.conf(5).
.TP 6n
\fRinvalid environment variable name\fR
One or more environment variable names specified via the
\fB\-E\fR
option contained an equal sign
(\(oq=\(cq).
The arguments to the
\fB\-E\fR
option should be environment variable names without an associated value.
.TP 6n
\fRno password was provided\fR
When
\fBsudo\fR
tried to read the password, it did not receive any characters.
This may happen if no terminal is available (or the
\fB\-S\fR
option is specified) and the standard input has been redirected from
\fI/dev/null\fR.
.TP 6n
\fRa terminal is required to read the password\fR
\fBsudo\fR
needs to read the password but there is no mechanism available for it
to do so.
A terminal is not present to read the password from,
\fBsudo\fR
has not been configured to read from the standard input,
the
\fB\-S\fR
option was not used, and no askpass helper has been specified either via the
sudo.conf(5)
file or the
\fRSUDO_ASKPASS\fR
environment variable.
.TP 6n
\fRno writable temporary directory found\fR
\fBsudoedit\fR
was unable to find a usable temporary directory in which to store its
intermediate files.
.TP 6n
\fRsudo must be owned by uid 0 and have the setuid bit set\fR
\fBsudo\fR
was not run with root privileges.
The
\fBsudo\fR
binary does not have the correct owner or permissions.
It must be owned by the root user and have the set-user-ID bit set.
.TP 6n
\fRsudoedit is not supported on this platform\fR
It is only possible to run
\fBsudoedit\fR
on systems that support setting the effective user-ID.
.TP 6n
\fRtimed out reading password\fR
The user did not enter a password before the password timeout
(5 minutes by default) expired.
.TP 6n
\fRyou do not exist in the passwd database\fR
Your user-ID does not appear in the system passwd database.
.TP 6n
\fRyou may not specify environment variables in edit mode\fR
It is only possible to specify environment variables when running
a command.
When editing a file, the editor is run with the user's environment unmodified.
.SH "SEE ALSO"
su(1),
stat(2),
login_cap(3),
passwd(5),
sudo.conf(5),
sudo_plugin(5),
sudoers(5),
sudoreplay(8),
visudo(8)
.SH "HISTORY"
See the HISTORY file in the
\fBsudo\fR
distribution (https://www.sudo.ws/history.html) for a brief
history of sudo.
.SH "AUTHORS"
Many people have worked on
\fBsudo\fR
over the years; this version consists of code written primarily by:
.sp
.RS 6n
Todd C. Miller
.RE
.PP
See the CONTRIBUTORS file in the
\fBsudo\fR
distribution (https://www.sudo.ws/contributors.html) for an
exhaustive list of people who have contributed to
\fBsudo\fR.
.SH "CAVEATS"
There is no easy way to prevent a user from gaining a root shell
if that user is allowed to run arbitrary commands via
\fBsudo\fR.
Also, many programs (such as editors) allow the user to run commands
via shell escapes, thus avoiding
\fBsudo\fR's
checks.
However, on most systems it is possible to prevent shell escapes with the
sudoers(5)
plugin's
\fInoexec\fR
functionality.
.PP
It is not meaningful to run the
\fRcd\fR
command directly via sudo, e.g.,
.nf
.sp
.RS 6n
$ sudo cd /usr/local/protected
.RE
.fi
.PP
since when the command exits the parent process (your shell) will
still be the same.
Please see the
\fIEXAMPLES\fR
section for more information.
.PP
Running shell scripts via
\fBsudo\fR
can expose the same kernel bugs that make set-user-ID shell scripts
unsafe on some operating systems (if your OS has a /dev/fd/ directory,
set-user-ID shell scripts are generally safe).
.SH "BUGS"
If you feel you have found a bug in
\fBsudo\fR,
please submit a bug report at https://bugzilla.sudo.ws/
.SH "SUPPORT"
Limited free support is available via the sudo-users mailing list,
see https://www.sudo.ws/mailman/listinfo/sudo-users to subscribe or
search the archives.
.SH "DISCLAIMER"
\fBsudo\fR
is provided
\(lqAS IS\(rq
and any express or implied warranties, including, but not limited
to, the implied warranties of merchantability and fitness for a
particular purpose are disclaimed.
See the LICENSE file distributed with
\fBsudo\fR
or https://www.sudo.ws/license.html for complete details.
